nowarn	aln
.model	tiny
.radix	16
.code
.386p
one=838d
locals	@_
cpuid	macro
	db	0f,0a2
endm
	org	100
start:	cld
	push	8000
	pop	es
	xor	si,si
	xor	di,di
	mov	cx,4000
	rep	movsd
	push	es
	pop	ds
	push	es
	pop	ss
	push	cs
	push	offset @ret
	push	es
	push	offset @start
	retf
@ret:	ret

@start:	mov	si,offset OutPut
	call	@back
	retf
@back:	lodsb
	cmp	al,0
	jz	@_1
	cmp	al,-1
	jz	@_2
	mov	dl,al
	mov	ah,6
	int	21
	jmp	@back
@_2:	lodsw
	call	ax
	jmp	@back
@_1:	ret
	align	4
Flush_Cache proc near
	push	bx
	push	cx
	push	si
	push	ds
	xor	bx,bx
@_1:	mov	ds,bx
	xor	si,si
	mov	cx,4000
	rep	lodsd
	add	bx,1000
	cmp	bx,8000
	jb	@_1
	pop	ds
	pop	si
	pop	cx
	pop	bx
	ret
endp
	align	4
Put_Number proc	near
	pusha
	mov	bx,10d
	mov	cx,8
@_2:	xor	dx,dx
	div	bx
	xchg	ax,dx
	add	al,'0'
	push	ax
	xchg	ax,dx
	or	ax,ax
	loopnz	@_2
	mov	al,' '
	jcxz	@_1
@_4:	push	ax
	loop	@_4
@_1:	mov	cx,8
@_3:	pop	ax
	mov	ah,6
	mov	dl,al
	int	21
	loop	@_3
	popa
	ret
endp
	align	4
Put_Aln_Number proc near
	push	cx
	push	dx
	mov	cx,bx
	shr	cx,1
	add	ax,cx
	xor	dx,dx
	div	bx
	imul	ax,bx
	call	Put_Number
	pop	dx
	pop	cx
	ret
endp
	align	4
Time_Start proc	near
	cli
	push	ax
	mov	ax,8001
	int	2a
	in	al,61
	and	al,not 11b
	out	61,al
	mov	al,10110000b
	out	43,al
	mov	al,0
	out	42,al
	out	42,al
@_1:	in	al,61
	test	al,10
	jnz	@_1
@_2:	in	al,61
	test	al,10
	jz	@_2
@_3:	in	al,61
	test	al,10
	jnz	@_3
	or	al,1
	out	61,al
	pop	ax
	ret
endp
	align	4
Time_Stop proc	near
	mov	al,11001000b
	out	43,al
	in	al,42
	test	al,10000000b
	jnz	@_1
	in	al,42
	mov	ah,al
	in	al,42
	xchg	ah,al
	neg	ax
	push	ax
	mov	ax,8101
	int	2a
	pop	ax
	clc
	ret
@_1:	in	al,42
	in	al,42
	xor	ax,ax
	push	ax
	mov	ax,8101
	int	2a
	pop	ax
	stc
	ret
endp
	align	4
VGA_Time proc	near
	mov	dx,3da
@_2:	in	al,dx
	test	al,8
	jz	@_2
@_3:	in	al,dx
	test	al,8
	jnz	@_3
	lodsw
	call	Time_Start
	call	ax
	call	Time_Stop
	jnc	@_1
	xor	ax,ax
@_1:	add	ax,2
	shr	ax,2
	mov	bx,5
	call	Put_Aln_Number
	ret
endp
	align	4
VGA_Read_Byte proc near
	push	ds
	push	si
	xor	si,si
	push	0bc00
	pop	ds
	mov	cx,one*4
	rep	lodsb
	pop	si
	pop	ds
	ret
endp
	align	4
VGA_Read_Word proc near
	push	ds
	push	si
	xor	si,si
	push	0bc00
	pop	ds
	mov	cx,one*4
	rep	lodsw
	pop	si
	pop	ds
	ret
endp
	align	4
VGA_Read_DWord proc near
	push	ds
	push	si
	xor	si,si
	push	0bc00
	pop	ds
	mov	cx,one*4
	rep	lodsd
	pop	si
	pop	ds
	ret
endp
	align	4
VGA_Write_Byte proc near
	push	es
	push	di
	xor	di,di
	push	0bc00
	pop	es
	mov	cx,one*4
	rep	stosb
	pop	di
	pop	es
	ret
endp
	align	4
VGA_Write_Word proc near
	push	es
	push	di
	xor	di,di
	push	0bc00
	pop	es
	mov	cx,one*4
	rep	stosw
	pop	di
	pop	es
	ret
endp
	align	4
VGA_Write_DWord proc near
	push	es
	push	di
	xor	di,di
	push	0bc00
	pop	es
	mov	cx,one*4
	rep	stosd
	pop	di
	pop	es
	ret
endp
	align	4
CPU_Test proc	near
	pushf
	pushf
	pop	ax
	and	ax,0fff
	or	ax,3000
	mov	bx,ax
	push	ax
	popf
	pushf
	pop	ax
	popf
	cmp	ax,bx
	jz	@_1
	mov	si,offset @_msg1
	ret
@_1:	smsw	ax
	test	al,1
	jz	@_2
	mov	si,offset @_msg2
	call	@back
	mov	si,offset out1
@_2:
;	cpuid

;	push	0
;	pop	es
;	push	ds
;	push	si
;	mov	word ptr es:[467],offset @_3
;	mov	es:[467+2],cs
;	mov	word ptr @_stack,sp
;	mov	word ptr @_stack+2,ss
;	call	Flush_Cache
;	mov	al,8f
;	out	70,al
;	mov	al,0a
;	out	71,al
;	mov	al,0fe
;	out	64,al
;	jmp	$
;@_3:	lss	sp,cs:@_stack
;	pop	si
;	pop	ds
;	mov	eax,edx
;	shr	eax,18
;	call	Put_Number
	ret
;@_stack	dd	?
@_msg1	db	'less than 80386',0dh,0a,0
@_msg2	db	'V86 (timing parameters may be vary)',0dh,0a,0
endp
	align	4
CPU_Clock proc	near
	push	si
	mov	cx,one
	call	Time_Start
	jmp	@_1
	align	10
@_1:
rept	512d
	inc	ax
endm
	dec	cx
	jnz	@_1
	call	Time_Stop
	xor	dx,dx
	mov	bx,512d+4
	mov	cx,bx
	shr	cx,1
	add	ax,cx
	div	bx
	mov	CPU_CLK,ax
	call	Put_Number
	pop	si
	ret
	align	4
CPU_CLK	dw	?
endp
	align	4
Block_Read proc	near
	push	ds
	push	si
	push	9000
	pop	ds
	call	Flush_Cache
	call	Time_Start
	call	@_1
	call	Time_Stop
	mov	bx,cs:CPU_CLK
	call	Put_Aln_Number
	call	Flush_Cache
	xor	si,si
	mov	cx,2000
	rep	lodsd
	call	Time_Start
	call	@_1
	call	Time_Stop
	mov	bx,cs:CPU_CLK
	call	Put_Aln_Number
	call	Flush_Cache
	xor	si,si
	mov	cx,one
	rep	lodsd
	call	Time_Start
	call	@_1
	call	Time_Stop
	mov	bx,cs:CPU_CLK
	call	Put_Aln_Number
	pop	si
	pop	ds
	ret
@_1:	cld
	xor	si,si
	mov	cx,one
	rep	lodsd
	ret
endp
	align	4
Block_Write proc near
	push	si
	push	ds
	push	9000
	pop	es
	call	Flush_Cache
	call	Time_Start
	call	@_1
	call	Time_Stop
	mov	bx,cs:CPU_CLK
	call	Put_Aln_Number
	call	Flush_Cache
	xor	si,si
	mov	cx,2000
	rep	lods dword ptr es:[si]
	call	Time_Start
	call	@_1
	call	Time_Stop
	mov	bx,cs:CPU_CLK
	call	Put_Aln_Number
	call	Flush_Cache
	xor	si,si
	mov	cx,one
	rep	lods dword ptr es:[si]
	call	Time_Start
	call	@_1
	call	Time_Stop
	mov	bx,cs:CPU_CLK
	call	Put_Aln_Number
	pop	ds
	pop	si
	ret
@_1:	cld
	xor	di,di
	mov	cx,one
	rep	stosd
	ret
endp
	align	4
Block_Move proc	near
	push	si
	push	ds
	push	9000
	pop	ds
	push	9800
	pop	es
	call	Flush_Cache
	call	Time_Start
	call	@_1
	call	Time_Stop
	mov	bx,cs:CPU_CLK
	call	Put_Aln_Number
	call	Flush_Cache
	mov	si,8000
	mov	cx,2000
	rep	lodsd
	xor	si,si
	mov	cx,2000
	rep	lodsd
	call	Time_Start
	call	@_1
	call	Time_Stop
	mov	bx,cs:CPU_CLK
	call	Put_Aln_Number
	call	Flush_Cache
	mov	si,8000
	mov	cx,one
	rep	lodsd
	xor	si,si
	mov	cx,one
	rep	lodsd
	call	Time_Start
	call	@_1
	call	Time_Stop
	mov	bx,cs:CPU_CLK
	call	Put_Aln_Number
	pop	ds
	xor	dx,dx
	div	bx
	mov	si,offset @_msg1
	cmp	ax,3
	jz	@_2
	mov	si,offset @_msg2
	cmp	ax,4
	jz	@_2
	mov	si,offset @_msg3
	cmp	ax,5
	jz	@_2
	mov	si,offset @_msg4
@_2:	call	@back
	pop	si
	ret
@_1:	cld
	xor	si,si
	xor	di,di
	mov	cx,one
	rep	movsd
	ret
@_msg1	db	'  (0 write wait states)',0
@_msg2	db	'  (1 write wait states)',0
@_msg3	db	'  (2 write wait states)',0
@_msg4	db	'  (can''t determine write wait state number)',0
endp
	align	4
Line_Read_Loaded proc near
	push	si
	push	ds
	push	9000
	pop	ds
	call	Flush_Cache
	xor	si,si
	mov	cx,4000
	rep	lodsd
	xor	si,si
	mov	cx,one*8
	call	Time_Start
	jmp	@_1
	align	10
@_1:	mov	ax,[si]
	mov	ax,[si+40]
	mov	bx,[si+60]
	add	si,80
	dec	cx
	jnz	@_1
	call	Time_Stop
	push	ax
	call	Flush_Cache
	xor	si,si
	mov	cx,4000
	rep	lodsd
	xor	si,si
	mov	cx,one*8
	call	Time_Start
	jmp	@_2
	align	10
@_2:	mov	ax,[si]
	mov	bx,[si+20]
	mov	ax,[si+40]
	mov	bx,[si+60]
	add	si,80
	dec	cx
	jnz	@_2
	call	Time_Stop
	pop	cx
	sub	ax,cx
	add	ax,4
	shr	ax,3
	mov	bx,5
	call	Put_Aln_Number
	mov	bx,cs:CPU_CLK
	pop	ds
	xor	dx,dx
	div	bx
	mov	si,offset @_msg1
	cmp	ax,5
	jz	@_3
	mov	si,offset @_msg2
	cmp	ax,8
	jz	@_3
	mov	si,offset @_msg3
	cmp	ax,9
	jz	@_3
	mov	si,offset @_msg4
	cmp	ax,12d
	jz	@_3
	mov	si,offset @_msg6
	cmp	ax,6
	jz	@_3
	mov	si,offset @_msg5
@_3:	call	@back
	pop	si
	ret
@_msg1	db	'  (2-1-1-1 scheme)',0
@_msg2	db	'  (2-2-2-2 scheme)',0
@_msg3	db	'  (3-2-2-2 scheme)',0
@_msg4	db	'  (3-3-3-3 scheme)',0
@_msg5	db	'  (unknown scheme or external cache absent)',0
@_msg6	db	'  (3-1-1-1 scheme)',0
endp
	align	4
Line_Read_Empty proc near
	push	ds
	push	si
	push	9000
	pop	ds
	call	Flush_Cache
	xor	si,si
	mov	cx,one/2
	call	Time_Start
	jmp	@_1
	align	10
@_1:	mov	ax,[si]
	mov	ax,[si+40]
	mov	bx,[si+60]
	add	si,80
	dec	cx
	jnz	@_1
	call	Time_Stop
	push	ax
	call	Flush_Cache
	xor	si,si
	mov	cx,one/2
	call	Time_Start
	jmp	@_2
	align	10
@_2:	mov	ax,[si]
	mov	bx,[si+20]
	mov	ax,[si+40]
	mov	bx,[si+60]
	add	si,80
	dec	cx
	jnz	@_2
	call	Time_Stop
	pop	cx
	sub	ax,cx
	add	ax,ax
	mov	bx,5
	call	Put_Aln_Number
	pop	si
	pop	ds
	ret
endp
Port_Read proc	near
	lodsw
	mov	dx,ax
	push	si
	call	Flush_Cache
	push	9000
	pop	es
	xor	si,si
	mov	cx,400
	rep	lods dword ptr es:[si]
	mov	cx,one
	xor	di,di
	call	Time_Start
	rep	insb
	call	Time_Stop
	mov	bx,cs:CPU_CLK
	call	Put_Aln_Number
	call	Flush_Cache
	xor	si,si
	mov	cx,400
	rep	lods dword ptr es:[si]
	mov	cx,one
	xor	di,di
	call	Time_Start
	rep	insw
	call	Time_Stop
	mov	bx,cs:CPU_CLK
	call	Put_Aln_Number
	pop	si
	ret
endp
Port_Write proc	near
	lodsw
	mov	dx,ax
	push	si
	push	ds
	call	Flush_Cache
	push	9000
	pop	ds
	xor	si,si
	mov	cx,400
	rep	lodsd
	mov	cx,one
	xor	si,si
	xor	ax,ax
	call	Time_Start
	rep	outsb
	call	Time_Stop
	mov	bx,cs:CPU_CLK
	call	Put_Aln_Number
	call	Flush_Cache
	xor	si,si
	mov	cx,400
	rep	lodsd
	mov	cx,one
	xor	si,si
	xor	ax,ax
	call	Time_Start
	rep	outsw
	call	Time_Stop
	mov	bx,cs:CPU_CLK
	call	Put_Aln_Number
	pop	ds
	pop	si
	ret
endp
OutPut	db	'    Motherboard timing measure program',0dh,0a
	db	'        for 80386+ based computers',0dh,0a
	db	'            Written by U. Temkin',0dh,0a
	db	0dh,0a
	db	'CPU type = '
	db	-1
	dw	CPU_Test
	db	'80?86       '
out1	db	'CPU clock time (ns) = '
	db	-1
	dw	CPU_Clock
	db	0dh,0a
	db	0dh,0a
	db	'VGA access time (ns) for   read    write',0dh,0a
	db	'         byte           '
	db	-1
	dw	VGA_Time,VGA_Read_Byte
	db	-1
	dw	VGA_Time,VGA_Write_Byte
	db	0dh,0a
	db	'         word           '
	db	-1
	dw	VGA_Time,VGA_Read_Word
	db	-1
	dw	VGA_Time,VGA_Write_Word
	db	0dh,0a
	db	'         dword          '
	db	-1
	dw	VGA_Time,VGA_Read_DWord
	db	-1
	dw	VGA_Time,VGA_Write_DWord
	db	0dh,0a
	db	0dh,0a
	db	'                                 Cache preload',0dh,0a
	db	'                            none  external ext+int',0dh,0a
	db	'DWord read time (ns)    '
	db	-1
	dw	Block_Read
	db	0dh,0a
	db	'DWord write time (ns)   '
	db	-1
	dw	Block_Write
	db	0dh,0a
	db	'DWord move time (ns)    '
	db	-1
	dw	Block_Move
	db	0dh,0a
	db	0dh,0a
	db	'Internal cache line read time (ns)',0dh,0a
	db	'  external cache preloaded'
	db	-1
	dw	Line_Read_Loaded
	db	0dh,0a
	db	'  external cache empty    '
	db	-1
	dw	Line_Read_Empty
	db	0dh,0a
	db	0dh,0a
	db	'                              empty port<100  empty port>100     VGA port',0dh,0a
	db	'ISA port operation time (ns)   byte    word    byte    word    byte    word',0dh,0a
	db	'              read         '
	db	-1
	dw	Port_Read,0e0
	db	-1
	dw	Port_Read,110
	db	-1
	dw	Port_Read,3ce
	db	0dh,0a
	db	'              write        '
	db	-1
	dw	Port_Write,0e0
	db	-1
	dw	Port_Write,110
	db	-1
	dw	Port_Write,3ce
	db	0dh,0a
	db	0
end	start
